%module(directors="1", allprotected="1") "IMP.benchmark"
%feature("autodoc", 1);
// turn off the warning as it mostly triggers on methods (and lots of them)
%warnfilter(321);

%inline %{
namespace IMP {
namespace kernel {
}
using namespace kernel;
}
%}

%{
#include <boost/version.hpp>
#if BOOST_VERSION > 103600
#if BOOST_VERSION > 103800
#include <boost/exception/all.hpp>
#else
#include <boost/exception.hpp>
#endif
#endif

#include <boost/type_traits/is_convertible.hpp>
#include <boost/utility/enable_if.hpp>
#include <exception>

%}

%{
#include "IMP/base.h"
#include "IMP/base/base_config.h"
%}

%{
#include <IMP/base/internal/swig.h>
%}
%{
#include <IMP/base/internal/swig_helpers.h>
%}
%{
#include "IMP/benchmark.h"
#include "IMP/benchmark/benchmark_config.h"
%}


%implicitconv;
%include "std_vector.i"
%include "std_string.i"
%include "std_pair.i"


%pythoncode %{
_value_types=[]
_object_types=[]
_raii_types=[]
_plural_types=[]
%}

%include "typemaps.i"

#ifdef NDEBUG
#error "The python wrappers must not be built with NDEBUG"
#endif


%include "IMP/base/base_config.h" 
%include "IMP_base.compiler_warnings.i"
%include "IMP_base.directors.i"
%include "IMP_base.exceptions.i"
%include "IMP_base.refcount.i"
%include "IMP_base.streams.i"
%include "IMP_base.streams_kernel.i"
%include "IMP_base.types.i"
%include "IMP/base/base_macros.h"
%include "IMP/base/bracket_macros.h"
%include "IMP/base/check_macros.h"
%include "IMP/base/comparison_macros.h"
%include "IMP/base/compiler_macros.h"
%include "IMP/base/deprecation_macros.h"
%include "IMP/base/doxygen_macros.h"
%include "IMP/base/graph_macros.h"
%include "IMP/base/hash_macros.h"
%include "IMP/base/log_macros.h"
%include "IMP/base/nullptr_macros.h"
%include "IMP/base/object_macros.h"
%include "IMP/base/raii_macros.h"
%include "IMP/base/ref_counted_macros.h"
%include "IMP/base/showable_macros.h"
%include "IMP/base/swap_macros.h"
%include "IMP/base/swig_macros.h"
%include "IMP/base/thread_macros.h"
%include "IMP/base/tuple_macros.h"
%include "IMP/base/utility_macros.h"
%include "IMP/base/value_macros.h"
%include "IMP/base/warning_macros.h"
%import "IMP_base.i"
%include "IMP/benchmark/benchmark_config.h" 
%include "IMP/benchmark/benchmark_macros.h"
%include "IMP_benchmark.impl.i"

namespace IMP {
namespace benchmark {
const std::string get_module_version();
std::string get_example_path(std::string fname);
std::string get_data_path(std::string fname);
}
}

%pythoncode %{
import _version_check
_version_check.check_version(get_module_version())
%}
